package com.example.labbluetooth;

import android.app.Activity;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import app.akexorcist.bluetotohspp.library.BluetoothSPP;
import app.akexorcist.bluetotohspp.library.BluetoothState;
import app.akexorcist.bluetotohspp.library.DeviceList;

public class Main2Activity extends AppCompatActivity {

    final String KP1_UP = "A";
    final String KP2_UP = "D";
    final String KP3_UP = "G";
    final String KI1_UP = "B";
    final String KI2_UP = "E";
    final String KI3_UP = "H";
    final String KD1_UP = "C";
    final String KD2_UP = "F";
    final String KD3_UP = "I";
    final String KP1_DOWN = "a";
    final String KP2_DOWN = "d";
    final String KP3_DOWN = "g";
    final String KI1_DOWN= "b";
    final String KI2_DOWN = "e";
    final String KI3_DOWN = "h";
    final String KD1_DOWN = "c";
    final String KD2_DOWN = "f";
    final String KD3_DOWN = "i";
    final String BALANCE_UP = "8";
    final String BALANCE_DOWN = "9";

    int KP1 = 0;
    int KP2 = 0;
    int KP3 = 0;
    double KI1 = 0;
    double KI2 = 0;
    double KI3 = 0;
    int KD1 = 0;
    int KD2 = 0;
    int KD3 = 0;
    double BALANCE = 0;
    double INCREMENT = 0.005;
    int INCREMENT_KP = 10;
    double INCREMENT_KI = 0.1;
    int INCREMENT_KD = 100;

    BluetoothSPP bluetooth;

    Button Kp1_up;
    Button Kp2_up;
    Button Ki1_up;
    Button Ki2_up;
    Button Kd1_up;
    Button Kd2_up;
    Button Kp1_down;
    Button Kp2_down;
    Button Ki1_down;
    Button Ki2_down;
    Button Kd1_down;
    Button Kd2_down;
    Button Kp3_up;
    Button Ki3_up;
    Button Kd3_up;
    Button Kp3_down;
    Button Ki3_down;
    Button Kd3_down;
    Button next;
    Button previous;

    Button balance_up;
    Button balance_down;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main2);

        //bluetooth = new BluetoothSPP(this);
        bluetooth = BluetoothContextApplication.getInstance().getBluetoothSPP();

        Kp1_up = (Button) findViewById(R.id.Kp1up);
        Kp2_up = (Button) findViewById(R.id.Kp2up);
        Kp3_up= (Button) findViewById(R.id.Kp3up);
        Ki1_up = (Button) findViewById(R.id.Ki1up);
        Ki2_up = (Button) findViewById(R.id.Ki2up);
        Ki3_up = (Button) findViewById(R.id.Ki3up);
        Kd1_up = (Button) findViewById(R.id.Kd1up);
        Kd2_up = (Button) findViewById(R.id.Kd2up);
        Kd3_up = (Button) findViewById(R.id.Kd3up);
        Kp1_down = (Button) findViewById(R.id.Kp1down);
        Kp2_down = (Button) findViewById(R.id.Kp2down);
        Kp3_down= (Button) findViewById(R.id.Kp3down);
        Ki1_down = (Button) findViewById(R.id.Ki1down);
        Ki2_down = (Button) findViewById(R.id.Ki2down);
        Ki3_down = (Button) findViewById(R.id.Ki3down);
        Kd1_down = (Button) findViewById(R.id.Kd1down);
        Kd2_down = (Button) findViewById(R.id.Kd2down);
        Kd3_down = (Button) findViewById(R.id.Kd3down);
        balance_up = (Button) findViewById(R.id.balance_up);
        balance_down = (Button) findViewById(R.id.balanace_down);
        next = (Button) findViewById(R.id.next2);
        previous = (Button) findViewById(R.id.previous2);
        final TextView Kp1_text= (TextView) findViewById(R.id.Kp1uptext);
        final TextView Kp2_text= (TextView) findViewById(R.id.Kp2uptext);
        final TextView Kp3_text= (TextView) findViewById(R.id.Kp3uptext);
        final TextView Ki1_text= (TextView) findViewById(R.id.Ki1uptext);
        final TextView Ki2_text= (TextView) findViewById(R.id.Ki2uptext);
        final TextView Ki3_text= (TextView) findViewById(R.id.Ki3uptext);
        final TextView Kd1_text= (TextView) findViewById(R.id.Kd1uptext);
        final TextView Kd2_text= (TextView) findViewById(R.id.Kd2uptext);
        final TextView Kd3_text= (TextView) findViewById(R.id.Kd3uptext);

        Kp1_text.setText(String.valueOf(KP1));
        Ki1_text.setText(String.valueOf(KI1));
        Kd1_text.setText(String.valueOf(KD1));
        Kp2_text.setText(String.valueOf(KP2));
        Ki2_text.setText(String.valueOf(KI2));
        Kd2_text.setText(String.valueOf(KD2));
        Kp3_text.setText(String.valueOf(KP3));
        Ki3_text.setText(String.valueOf(KI3));
        Kd3_text.setText(String.valueOf(KD3));

        final TextView Balance_text= (TextView) findViewById(R.id.balance_textid);

        if (!bluetooth.isBluetoothAvailable()) {
            Toast.makeText(getApplicationContext(), "Bluetooth is not available", Toast.LENGTH_SHORT).show();
            finish();
        }


        next.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent i = new Intent(getApplicationContext(), Main3Activity.class);
                startActivity(i);
            }
        });

       previous.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent i = new Intent(getApplicationContext(), MainActivity.class);
                startActivity(i);
            }
        });

        Kp1_up.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KP1 = KP1 + INCREMENT_KP;
                Kp1_text.setText(String.valueOf(KP1));
                bluetooth.send(KP1_UP, false);
            }
        });

        Kp2_up.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KP2 = KP2 + INCREMENT_KP;
                Kp2_text.setText(String.valueOf(KP2));
                bluetooth.send(KP2_UP, false);
            }
        });

        Kp3_up.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KP3 = KP3 + INCREMENT_KP;
                Kp3_text.setText(String.valueOf(KP3));
                bluetooth.send(KP3_UP, false);
            }
        });

        Ki1_up.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KI1 = KI1 + INCREMENT_KI;
                Ki1_text.setText(String.valueOf(KI1));
                bluetooth.send(KI1_UP, false);
            }
        });

        Ki2_up.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KI2 = KI2 + INCREMENT_KI;
                Ki2_text.setText(String.valueOf(KI2));
                bluetooth.send(KI2_UP, false);
            }
        });

        Ki3_up.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KI3 = KI3 + INCREMENT_KI;
                Ki3_text.setText(String.valueOf(KI3));
                bluetooth.send(KI3_UP, false);
            }
        });

        Kd1_up.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KD1 = KD1 + INCREMENT_KD;
                Kd1_text.setText(String.valueOf(KD1));
                bluetooth.send(KD1_UP, false);
            }
        });

        Kd2_up.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KD2 = KD2 + INCREMENT_KD;
                Kd2_text.setText(String.valueOf(KD2));
                bluetooth.send(KD2_UP, false);
            }
        });

        Kd3_up.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KD3 = KD3 + INCREMENT_KD;
                Kd3_text.setText(String.valueOf(KD3));
                bluetooth.send(KD3_UP, false);
            }
        });

        Kp1_down.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KP1 = KP1 - INCREMENT_KP;
                Kp1_text.setText(String.valueOf(KP1));
                bluetooth.send(KP1_DOWN, false);
            }
        });

        Kp2_down.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KP2 = KP2 - INCREMENT_KP;
                Kp2_text.setText(String.valueOf(KP2));
                bluetooth.send(KP2_DOWN, false);
            }
        });

        Kp3_down.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KP3 = KP3 - INCREMENT_KP;
                Kp3_text.setText(String.valueOf(KP3));
                bluetooth.send(KP3_DOWN, false);
            }
        });

        Ki1_down.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KI1 = KI1 - INCREMENT_KI;
                Ki1_text.setText(String.valueOf(KI1));
                bluetooth.send(KI1_DOWN, false);
            }
        });

        Ki2_down.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KI2 = KI2 - INCREMENT_KI;
                Ki2_text.setText(String.valueOf(KI2));
                bluetooth.send(KI2_DOWN, false);
            }
        });

        Ki3_down.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KI3 = KI3 - INCREMENT_KI;
                Ki3_text.setText(String.valueOf(KI3));
                bluetooth.send(KI3_DOWN, false);
            }
        });

        Kd1_down.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KD1 = KD1 - INCREMENT_KD;
                Kd1_text.setText(String.valueOf(KD1));
                bluetooth.send(KD1_DOWN, false);
            }
        });

        Kd2_down.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KD2 = KD2 - INCREMENT_KD;
                Kd2_text.setText(String.valueOf(KD2));
                bluetooth.send(KD2_DOWN, false);
            }
        });

        Kd3_down.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                KD3 = KD3 - INCREMENT_KD;
                Kd3_text.setText(String.valueOf(KD3));
                bluetooth.send(KD3_DOWN, false);
            }
        });


        balance_up.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                BALANCE = BALANCE+INCREMENT;
                Balance_text.setText(String.valueOf(BALANCE));
                bluetooth.send(BALANCE_UP, false);
            }
        });

        balance_down.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                BALANCE = BALANCE-INCREMENT;
                Balance_text.setText(String.valueOf(BALANCE));
                bluetooth.send(BALANCE_DOWN, false);
            }
        });


    }

    public void onStart() {
        super.onStart();
        if (!bluetooth.isBluetoothEnabled()) {
            bluetooth.enable();
        } else {
            if (!bluetooth.isServiceAvailable()) {
                bluetooth.setupService();
                bluetooth.startService(BluetoothState.DEVICE_OTHER);
            }
        }
    }


    public void onDestroy() {
        super.onDestroy();
        //bluetooth.stopService();
    }

    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == BluetoothState.REQUEST_CONNECT_DEVICE) {
            if (resultCode == Activity.RESULT_OK)
                bluetooth.connect(data);
        } else if (requestCode == BluetoothState.REQUEST_ENABLE_BT) {
            if (resultCode == Activity.RESULT_OK) {
                bluetooth.setupService();
            } else {
                Toast.makeText(getApplicationContext()
                        , "Bluetooth was not enabled."
                        , Toast.LENGTH_SHORT).show();
                finish();
            }
        }
    }



}
