package com.example.labbluetooth;

import android.app.Application;

import app.akexorcist.bluetotohspp.library.BluetoothSPP;

public class BluetoothContextApplication extends Application {
    BluetoothSPP bluetoothSPP;

    private static BluetoothContextApplication sInstance;

    public static BluetoothContextApplication getInstance(){
        return sInstance;
    }

    public void onCreate(){
        super.onCreate();

        sInstance = this;
        this.setBluetoothSPP(new BluetoothSPP(this));
    }

    public void setBluetoothSPP(BluetoothSPP bluetoothSPP){
        this.bluetoothSPP = bluetoothSPP;
    }

    public BluetoothSPP getBluetoothSPP(){
        return this.bluetoothSPP;
    }
}
